package org.Hello;

import java.util.Date;
import javax.persistence.*;

@Entity
@Table(name="BUCHUNG")
public class Payment {
  @Id
  private int id;
  @ManyToOne
  @JoinColumn(name="KONTO", nullable=false)
  private Account account;
  @Column(name="DATUM")
  private Date date;
  @Column(name="BETRAG")
  private double amount;

  protected Payment() {
	id = (int)System.nanoTime();
	account = null;
	date = null;
	amount = 0;
  }

  public Payment(Account a, double am) {
	id = (int)System.nanoTime();
	account = a;
	date = new Date();
	amount = am;
	a.addPayment(this);
  }

  public String toString() {
	return "  " + date + " : " + amount;
  }
}
