package org.Hello;

import javax.ejb.*;
import javax.annotation.*;
import javax.interceptor.*;

@Stateful
public class HelloImpl implements HelloRemote
{
  private static int ctr = 0;
  private int nr = 0;

  // Referenz auf MyBean, wird vom Container initialisiert
  @EJB private MyBeanLocal myBean;

  public HelloImpl()
  {
	nr = ++ctr;
  }

  public String sayHello()
  {
    return "Hallo " + myBean.getName() + " from " + nr;
  }

  @Remove
  public String sayGoodBye()
  {
    return "Bye Bye " + myBean.getName() + " from " + nr;
  }

  @PostConstruct
  public void start() {
    System.out.println("@PostConstruct HelloImpl " + nr);
  }

  @PreDestroy 
  public void stop() {
    System.out.println("@PreDestroy HelloImpl " + nr);
  }

  @PostActivate
  public void act() {
    System.out.println("@PostActivate HelloImpl " + nr);
  }

  @PrePassivate 
  public void pass() {
    System.out.println("@PrePassivate HelloImpl " + nr);
  }

  @AroundInvoke
  public Object inv(InvocationContext c) throws Exception {
    System.out.println("HelloImpl " + nr + ": Calling " +
      c.getMethod().getName());
    return c.proceed();
  }
}
