package org.Hello;

import javax.ejb.*;
import javax.annotation.*;
import javax.interceptor.*;

@Stateful
public class MyBean implements MyBeanLocal
{
  private static int ctr = 0;
  private int nr = 0;

  // Session Context, wird vom Container initialisiert
  @Resource private SessionContext context;

  public MyBean()
  {
	nr = ++ctr;
  }

  public String getName()
  {
	// Namen des Aufrufers aus SessionContext auslesen
	return context.getCallerPrincipal().getName();
  }

  @PostConstruct
  public void start() {
    System.out.println("@PostConstruct MyBean " + nr);
  }

  @PreDestroy 
  public void stop() {
    System.out.println("@PreDestroy MyBean " + nr);
  }

  @PostActivate
  public void act() {
    System.out.println("@PostActivate MyBean " + nr);
  }

  @PrePassivate 
  public void pass() {
    System.out.println("@PrePassivate MyBean " + nr);
  }

  @AroundInvoke
  public Object inv(InvocationContext c) throws Exception {
    System.out.println("MyBean " + nr + ": Calling " +
      c.getMethod().getName());
    return c.proceed();
  }
}
